//---------------------------------------------------------------------
#include "MainWindow.h"
//---------------------------------------------------------------------
BAppMainWindow::BAppMainWindow(BRect frame,const char *title)
	:BWindow(frame,title,MAINWINDOW_WINDOWSTYLE,0)
{
	mainview=new BAppMainView(Bounds());	
	AddChild(mainview);
}
//---------------------------------------------------------------------
void BAppMainWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case MSG_MENUSELECT:
			mainview->strview->SetText(msg->FindString("text"));
			break;
		case MSG_SETMARKED:
			BMenuItem *item;
			msg->FindPointer("bmenuitem",(void **)&item);
			item->SetMarked(!(item->IsMarked()));
			break;
		default:
			BWindow::MessageReceived(msg);
	}
}
//---------------------------------------------------------------------
BAppMainView::BAppMainView(BRect frame)
	:BView(frame,"bappmainview",B_FOLLOW_ALL,B_WILL_DRAW)
{
	BRect viewrect(Bounds());

	BMenuBar *mainmenu=new BMenuBar(BRect(0,0,viewrect.right,24),
									   "mainmenubar");
	AddChild(mainmenu);

	BMenu *menu1=new BMenu("Menu1");
	menu1->AddItem(new BMenuItem("Test1_1",new BMessage(MSG_MENUSELECT)));
	menu1->ItemAt(0)->Message()->AddString("text",menu1->ItemAt(0)->Label());
	menu1->AddItem(new BMenuItem("Test1_2",new BMessage(MSG_MENUSELECT)));
	menu1->ItemAt(1)->Message()->AddString("text",menu1->ItemAt(1)->Label());
	mainmenu->AddItem(menu1);

	BMenu *menu2=new BMenu("Menu2");
	menu2->AddItem(new BMenuItem("Test2_1",new BMessage(MSG_MENUSELECT)));
	menu2->ItemAt(0)->Message()->AddString("text",menu2->ItemAt(0)->Label());
	menu2->AddItem(new BMenuItem("Test2_2",new BMessage(MSG_MENUSELECT)));
	menu2->ItemAt(1)->Message()->AddString("text",menu2->ItemAt(1)->Label());
	menu2->AddSeparatorItem();
	menu2->AddItem(new BMenuItem("Test2_3",new BMessage(MSG_MENUSELECT)));
	menu2->ItemAt(3)->Message()->AddString("text",menu2->ItemAt(3)->Label());

	BMenu *menu2_2=new BMenu("Menu2_4");
	menu2_2->AddItem(new BMenuItem("Test2_4_1",new BMessage(MSG_SETMARKED)));
	menu2_2->ItemAt(0)->Message()->AddPointer("bmenuitem",menu2_2->ItemAt(0));
	menu2_2->AddItem(new BMenuItem("Test2_4_2",new BMessage(MSG_SETMARKED)));
	menu2_2->ItemAt(1)->Message()->AddPointer("bmenuitem",menu2_2->ItemAt(1));

	menu2->AddItem(menu2_2);	

	mainmenu->AddItem(menu2);

	strview=new BStringView(BRect(8,38,viewrect.right-8,58),"strview",
	                        "NoData",
	                        B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP);
	AddChild(strview);
}
//---------------------------------------------------------------------
